#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>

#include "pin_macros.h"

#define TRIAC	C,5,H
#define SWT		C,4,L

ISR(TIMER2_COMP_vect){//   
	ON(TRIAC);
	_delay_us(25);
	OFF(TRIAC);
}

ISR(SIG_INTERRUPT0)//   .
{
	SFIOR|=_BV(PSR2);// Bit 0  PSR10: Prescaler Reset Timer/Counter1 and Timer/Counter0
	if (ACTIVE(SWT)) TCNT2=0;
	OCR2=5;
}

static void avr_init(void)
{
	
	DRIVER(TRIAC,OUT);
	DRIVER(SWT,PULLUP);
	
	MCUCR=(1<<ISC01)|(0<<ISC00);//1 1 The rising edge  //1 0 The falling edge of INT1 generates an interrupt request.
	GICR=_BV(INT0);//External Interrupt Request 0 Enable
	
	TIMSK=_BV(OCIE2);

	OCR2=5;
	TCCR2=(1<<CS22)|(1<<CS21)|(0<<CS20);//  256
	
	sei();

    return;
}

int main(void){
avr_init();

while(1){
	

	}
}